<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;regex-1.5.4&#x2F;src&#x2F;re_trait.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>re_trait.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../regex/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::fmt</span>;
<span class="kw">use</span> <span class="ident">std::iter::FusedIterator</span>;

<span class="doccomment">/// Slot is a single saved capture location. Note that there are two slots for</span>
<span class="doccomment">/// every capture in a regular expression (one slot each for the start and end</span>
<span class="doccomment">/// of the capture).</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">Slot</span> <span class="op">=</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>;

<span class="doccomment">/// Locations represents the offsets of each capturing group in a regex for</span>
<span class="doccomment">/// a single match.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Unlike `Captures`, a `Locations` value only stores offsets.</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Locations</span>(<span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Slot</span><span class="op">&gt;</span>);

<span class="kw">impl</span> <span class="ident">Locations</span> {
    <span class="doccomment">/// Returns the start and end positions of the Nth capture group. Returns</span>
    <span class="doccomment">/// `None` if `i` is not a valid capture group or if the capture group did</span>
    <span class="doccomment">/// not match anything. The positions returned are *always* byte indices</span>
    <span class="doccomment">/// with respect to the original string matched.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">pos</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">i</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">usize</span>, <span class="ident">usize</span>)<span class="op">&gt;</span> {
        <span class="kw">let</span> (<span class="ident">s</span>, <span class="ident">e</span>) <span class="op">=</span> (<span class="ident">i</span> <span class="op">*</span> <span class="number">2</span>, <span class="ident">i</span> <span class="op">*</span> <span class="number">2</span> <span class="op">+</span> <span class="number">1</span>);
        <span class="kw">match</span> (<span class="self">self</span>.<span class="number">0</span>.<span class="ident">get</span>(<span class="ident">s</span>), <span class="self">self</span>.<span class="number">0</span>.<span class="ident">get</span>(<span class="ident">e</span>)) {
            (<span class="prelude-val">Some</span>(<span class="kw-2">&amp;</span><span class="prelude-val">Some</span>(<span class="ident">s</span>)), <span class="prelude-val">Some</span>(<span class="kw-2">&amp;</span><span class="prelude-val">Some</span>(<span class="ident">e</span>))) <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>((<span class="ident">s</span>, <span class="ident">e</span>)),
            <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
        }
    }

    <span class="doccomment">/// Creates an iterator of all the capture group positions in order of</span>
    <span class="doccomment">/// appearance in the regular expression. Positions are byte indices</span>
    <span class="doccomment">/// in terms of the original string matched.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">iter</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">SubCapturesPosIter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
        <span class="ident">SubCapturesPosIter</span> { <span class="ident">idx</span>: <span class="number">0</span>, <span class="ident">locs</span>: <span class="self">self</span> }
    }

    <span class="doccomment">/// Returns the total number of capturing groups.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is always at least `1` since every regex has at least `1`</span>
    <span class="doccomment">/// capturing group that corresponds to the entire match.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">len</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">len</span>() <span class="op">/</span> <span class="number">2</span>
    }

    <span class="doccomment">/// Return the individual slots as a slice.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">as_slots</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">Slot</span>] {
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>.<span class="number">0</span>
    }
}

<span class="doccomment">/// An iterator over capture group positions for a particular match of a</span>
<span class="doccomment">/// regular expression.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Positions are byte indices in terms of the original string matched.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// `&#39;c` is the lifetime of the captures.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">SubCapturesPosIter</span><span class="op">&lt;</span><span class="lifetime">&#39;c</span><span class="op">&gt;</span> {
    <span class="ident">idx</span>: <span class="ident">usize</span>,
    <span class="ident">locs</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;c</span> <span class="ident">Locations</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;c</span><span class="op">&gt;</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">SubCapturesPosIter</span><span class="op">&lt;</span><span class="lifetime">&#39;c</span><span class="op">&gt;</span> {
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">usize</span>, <span class="ident">usize</span>)<span class="op">&gt;</span>;

    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">usize</span>, <span class="ident">usize</span>)<span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">idx</span> <span class="op">&gt;</span><span class="op">=</span> <span class="self">self</span>.<span class="ident">locs</span>.<span class="ident">len</span>() {
            <span class="kw">return</span> <span class="prelude-val">None</span>;
        }
        <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">locs</span>.<span class="ident">pos</span>(<span class="self">self</span>.<span class="ident">idx</span>) {
            <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="prelude-val">None</span>),
            <span class="prelude-val">Some</span>((<span class="ident">s</span>, <span class="ident">e</span>)) <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="prelude-val">Some</span>((<span class="ident">s</span>, <span class="ident">e</span>))),
        };
        <span class="self">self</span>.<span class="ident">idx</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
        <span class="ident">x</span>
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;c</span><span class="op">&gt;</span> <span class="ident">FusedIterator</span> <span class="kw">for</span> <span class="ident">SubCapturesPosIter</span><span class="op">&lt;</span><span class="lifetime">&#39;c</span><span class="op">&gt;</span> {}

<span class="doccomment">/// `RegularExpression` describes types that can implement regex searching.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This trait is my attempt at reducing code duplication and to standardize</span>
<span class="doccomment">/// the internal API. Specific duplication that is avoided are the `find`</span>
<span class="doccomment">/// and `capture` iterators, which are slightly tricky.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// It&#39;s not clear whether this trait is worth it, and it also isn&#39;t</span>
<span class="doccomment">/// clear whether it&#39;s useful as a public trait or not. Methods like</span>
<span class="doccomment">/// `next_after_empty` reak of bad design, but the rest of the methods seem</span>
<span class="doccomment">/// somewhat reasonable. One particular thing this trait would expose would be</span>
<span class="doccomment">/// the ability to start the search of a regex anywhere in a haystack, which</span>
<span class="doccomment">/// isn&#39;t possible in the current public API.</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">RegularExpression</span>: <span class="ident">Sized</span> <span class="op">+</span> <span class="ident">fmt::Debug</span> {
    <span class="doccomment">/// The type of the haystack.</span>
    <span class="kw">type</span> <span class="ident">Text</span>: <span class="question-mark">?</span><span class="ident">Sized</span> <span class="op">+</span> <span class="ident">fmt::Debug</span>;

    <span class="doccomment">/// The number of capture slots in the compiled regular expression. This is</span>
    <span class="doccomment">/// always two times the number of capture groups (two slots per group).</span>
    <span class="kw">fn</span> <span class="ident">slots_len</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span>;

    <span class="doccomment">/// Allocates fresh space for all capturing groups in this regex.</span>
    <span class="kw">fn</span> <span class="ident">locations</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Locations</span> {
        <span class="ident">Locations</span>(<span class="macro">vec!</span>[<span class="prelude-val">None</span>; <span class="self">self</span>.<span class="ident">slots_len</span>()])
    }

    <span class="doccomment">/// Returns the position of the next character after `i`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// For example, a haystack with type `&amp;[u8]` probably returns `i+1`,</span>
    <span class="doccomment">/// whereas a haystack with type `&amp;str` probably returns `i` plus the</span>
    <span class="doccomment">/// length of the next UTF-8 sequence.</span>
    <span class="kw">fn</span> <span class="ident">next_after_empty</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">text</span>: <span class="kw-2">&amp;</span><span class="ident"><span class="self">Self</span>::Text</span>, <span class="ident">i</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span>;

    <span class="doccomment">/// Returns the location of the shortest match.</span>
    <span class="kw">fn</span> <span class="ident">shortest_match_at</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">text</span>: <span class="kw-2">&amp;</span><span class="ident"><span class="self">Self</span>::Text</span>,
        <span class="ident">start</span>: <span class="ident">usize</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Returns whether the regex matches the text given.</span>
    <span class="kw">fn</span> <span class="ident">is_match_at</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">text</span>: <span class="kw-2">&amp;</span><span class="ident"><span class="self">Self</span>::Text</span>, <span class="ident">start</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span>;

    <span class="doccomment">/// Returns the leftmost-first match location if one exists.</span>
    <span class="kw">fn</span> <span class="ident">find_at</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">text</span>: <span class="kw-2">&amp;</span><span class="ident"><span class="self">Self</span>::Text</span>,
        <span class="ident">start</span>: <span class="ident">usize</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">usize</span>, <span class="ident">usize</span>)<span class="op">&gt;</span>;

    <span class="doccomment">/// Returns the leftmost-first match location if one exists, and also</span>
    <span class="doccomment">/// fills in any matching capture slot locations.</span>
    <span class="kw">fn</span> <span class="ident">captures_read_at</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">locs</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">Locations</span>,
        <span class="ident">text</span>: <span class="kw-2">&amp;</span><span class="ident"><span class="self">Self</span>::Text</span>,
        <span class="ident">start</span>: <span class="ident">usize</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">usize</span>, <span class="ident">usize</span>)<span class="op">&gt;</span>;

    <span class="doccomment">/// Returns an iterator over all non-overlapping successive leftmost-first</span>
    <span class="doccomment">/// matches.</span>
    <span class="kw">fn</span> <span class="ident">find_iter</span>(<span class="self">self</span>, <span class="ident">text</span>: <span class="kw-2">&amp;</span><span class="ident"><span class="self">Self</span>::Text</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Matches</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span>, <span class="self">Self</span><span class="op">&gt;</span> {
        <span class="ident">Matches</span> { <span class="ident">re</span>: <span class="self">self</span>, <span class="ident">text</span>: <span class="ident">text</span>, <span class="ident">last_end</span>: <span class="number">0</span>, <span class="ident">last_match</span>: <span class="prelude-val">None</span> }
    }

    <span class="doccomment">/// Returns an iterator over all non-overlapping successive leftmost-first</span>
    <span class="doccomment">/// matches with captures.</span>
    <span class="kw">fn</span> <span class="ident">captures_iter</span>(<span class="self">self</span>, <span class="ident">text</span>: <span class="kw-2">&amp;</span><span class="ident"><span class="self">Self</span>::Text</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">CaptureMatches</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span>, <span class="self">Self</span><span class="op">&gt;</span> {
        <span class="ident">CaptureMatches</span>(<span class="self">self</span>.<span class="ident">find_iter</span>(<span class="ident">text</span>))
    }
}

<span class="doccomment">/// An iterator over all non-overlapping successive leftmost-first matches.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Matches</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">R</span>: <span class="ident">RegularExpression</span>,
    <span class="ident">R::Text</span>: <span class="lifetime">&#39;t</span>,
{
    <span class="ident">re</span>: <span class="ident">R</span>,
    <span class="ident">text</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;t</span> <span class="ident">R::Text</span>,
    <span class="ident">last_end</span>: <span class="ident">usize</span>,
    <span class="ident">last_match</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span> <span class="ident">Matches</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">R</span>: <span class="ident">RegularExpression</span>,
    <span class="ident">R::Text</span>: <span class="lifetime">&#39;t</span>,
{
    <span class="doccomment">/// Return the text being searched.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">text</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;t</span> <span class="ident">R::Text</span> {
        <span class="self">self</span>.<span class="ident">text</span>
    }

    <span class="doccomment">/// Return the underlying regex.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">regex</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident">R</span> {
        <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">re</span>
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">Matches</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">R</span>: <span class="ident">RegularExpression</span>,
    <span class="ident">R::Text</span>: <span class="lifetime">&#39;t</span> <span class="op">+</span> <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span>,
{
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> (<span class="ident">usize</span>, <span class="ident">usize</span>);

    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">usize</span>, <span class="ident">usize</span>)<span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">last_end</span> <span class="op">&gt;</span> <span class="self">self</span>.<span class="ident">text</span>.<span class="ident">as_ref</span>().<span class="ident">len</span>() {
            <span class="kw">return</span> <span class="prelude-val">None</span>;
        }
        <span class="kw">let</span> (<span class="ident">s</span>, <span class="ident">e</span>) <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">re</span>.<span class="ident">find_at</span>(<span class="self">self</span>.<span class="ident">text</span>, <span class="self">self</span>.<span class="ident">last_end</span>) {
            <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="prelude-val">None</span>,
            <span class="prelude-val">Some</span>((<span class="ident">s</span>, <span class="ident">e</span>)) <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">s</span>, <span class="ident">e</span>),
        };
        <span class="kw">if</span> <span class="ident">s</span> <span class="op">=</span><span class="op">=</span> <span class="ident">e</span> {
            <span class="comment">// This is an empty match. To ensure we make progress, start</span>
            <span class="comment">// the next search at the smallest possible starting position</span>
            <span class="comment">// of the next match following this one.</span>
            <span class="self">self</span>.<span class="ident">last_end</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">re</span>.<span class="ident">next_after_empty</span>(<span class="self">self</span>.<span class="ident">text</span>, <span class="ident">e</span>);
            <span class="comment">// Don&#39;t accept empty matches immediately following a match.</span>
            <span class="comment">// Just move on to the next match.</span>
            <span class="kw">if</span> <span class="prelude-val">Some</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">=</span> <span class="self">self</span>.<span class="ident">last_match</span> {
                <span class="kw">return</span> <span class="self">self</span>.<span class="ident">next</span>();
            }
        } <span class="kw">else</span> {
            <span class="self">self</span>.<span class="ident">last_end</span> <span class="op">=</span> <span class="ident">e</span>;
        }
        <span class="self">self</span>.<span class="ident">last_match</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">e</span>);
        <span class="prelude-val">Some</span>((<span class="ident">s</span>, <span class="ident">e</span>))
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span> <span class="ident">FusedIterator</span> <span class="kw">for</span> <span class="ident">Matches</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">R</span>: <span class="ident">RegularExpression</span>,
    <span class="ident">R::Text</span>: <span class="lifetime">&#39;t</span> <span class="op">+</span> <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span>,
{
}

<span class="doccomment">/// An iterator over all non-overlapping successive leftmost-first matches with</span>
<span class="doccomment">/// captures.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">CaptureMatches</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span>(<span class="ident">Matches</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span>)
<span class="kw">where</span>
    <span class="ident">R</span>: <span class="ident">RegularExpression</span>,
    <span class="ident">R::Text</span>: <span class="lifetime">&#39;t</span>;

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span> <span class="ident">CaptureMatches</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">R</span>: <span class="ident">RegularExpression</span>,
    <span class="ident">R::Text</span>: <span class="lifetime">&#39;t</span>,
{
    <span class="doccomment">/// Return the text being searched.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">text</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;t</span> <span class="ident">R::Text</span> {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">text</span>()
    }

    <span class="doccomment">/// Return the underlying regex.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">regex</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident">R</span> {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">regex</span>()
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">CaptureMatches</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">R</span>: <span class="ident">RegularExpression</span>,
    <span class="ident">R::Text</span>: <span class="lifetime">&#39;t</span> <span class="op">+</span> <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span>,
{
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="ident">Locations</span>;

    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Locations</span><span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">last_end</span> <span class="op">&gt;</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">text</span>.<span class="ident">as_ref</span>().<span class="ident">len</span>() {
            <span class="kw">return</span> <span class="prelude-val">None</span>;
        }
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">locs</span> <span class="op">=</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">re</span>.<span class="ident">locations</span>();
        <span class="kw">let</span> (<span class="ident">s</span>, <span class="ident">e</span>) <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">re</span>.<span class="ident">captures_read_at</span>(
            <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">locs</span>,
            <span class="self">self</span>.<span class="number">0</span>.<span class="ident">text</span>,
            <span class="self">self</span>.<span class="number">0</span>.<span class="ident">last_end</span>,
        ) {
            <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="prelude-val">None</span>,
            <span class="prelude-val">Some</span>((<span class="ident">s</span>, <span class="ident">e</span>)) <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">s</span>, <span class="ident">e</span>),
        };
        <span class="kw">if</span> <span class="ident">s</span> <span class="op">=</span><span class="op">=</span> <span class="ident">e</span> {
            <span class="self">self</span>.<span class="number">0</span>.<span class="ident">last_end</span> <span class="op">=</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">re</span>.<span class="ident">next_after_empty</span>(<span class="self">self</span>.<span class="number">0</span>.<span class="ident">text</span>, <span class="ident">e</span>);
            <span class="kw">if</span> <span class="prelude-val">Some</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">=</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">last_match</span> {
                <span class="kw">return</span> <span class="self">self</span>.<span class="ident">next</span>();
            }
        } <span class="kw">else</span> {
            <span class="self">self</span>.<span class="number">0</span>.<span class="ident">last_end</span> <span class="op">=</span> <span class="ident">e</span>;
        }
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">last_match</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">e</span>);
        <span class="prelude-val">Some</span>(<span class="ident">locs</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span> <span class="ident">FusedIterator</span> <span class="kw">for</span> <span class="ident">CaptureMatches</span><span class="op">&lt;</span><span class="lifetime">&#39;t</span>, <span class="ident">R</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">R</span>: <span class="ident">RegularExpression</span>,
    <span class="ident">R::Text</span>: <span class="lifetime">&#39;t</span> <span class="op">+</span> <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span>,
{
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="regex" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>